﻿using System;
using System.Drawing;

using DevExpress.XtraEditors;
using DevExpress.XtraGauges.Core.Drawing;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            #region NEEDLE 복합 도형을 설정한다.

            ComplexShape needleComplexShape = (ComplexShape)this.arcScaleNeedleComponent.Shape;

            needleComplexShape.Collection.Clear();

            #endregion
            #region BASIC 폴리라인 도형을 설정한다.

            PolylineShape basicPolylineShape = new PolylineShape();

            basicPolylineShape.Name                    = "basicPolylineShape";
            basicPolylineShape.Appearance.ContentBrush = new SolidBrushObject(Color.Azure);
            basicPolylineShape.Points                  = new PointF[]
            {
                new PointF(25 ,  20),
                new PointF(100,  0 ),
                new PointF(25 , -20),
                new PointF(95 ,  0 ),
                new PointF(25 ,  20)
            };

            needleComplexShape.Add(basicPolylineShape);

            #endregion
            #region CAP 폴리라인 도형을 설정한다.

            PolylineShape capPolylineShape = new PolylineShape();
            
            capPolylineShape.Name                    = "capPolylineShape";
            capPolylineShape.Appearance.ContentBrush = new SolidBrushObject(Color.BurlyWood);
            capPolylineShape.Points                  = new PointF[]
            {
                new PointF(100,  0),
                new PointF(105,  5), 
                new PointF(110,  0),
                new PointF(105, -5)
            };

            needleComplexShape.Add(capPolylineShape);

            #endregion

            this.trackBarControl.EditValueChanged += trackBarControl_EditValueChanged;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 트랙바 컨트롤 편집 값 변경시 처리하기 - trackBarControl_EditValueChanged(sender, e)

        /// <summary>
        /// 트랙바 컨트롤 편집 값 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void trackBarControl_EditValueChanged(object sender, EventArgs e)
        {
            float value = Convert.ToSingle(this.trackBarControl.EditValue);

            this.arcScaleComponent.Value = value;

            this.arcScaleNeedleComponent.Value = value;
        }

        #endregion
    }
}